Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1470)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1477)
@@ -526,26 +489,25 @@
          zdtlw(:,:) = 0.0
 
-!        initialize aerosol indexes 
-!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-            call iniaerosol()
-
-      
-!        initialize tracer names, indexes and properties
-!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+!        Initialize aerosol indexes.
+!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~
+         call iniaerosol()
+
+      
+!        Initialize tracer names, indexes and properties.
+!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          tracerdyn=tracer
-         IF (.NOT.ALLOCATED(noms)) ALLOCATE(noms(nq)) !! because noms is an argument of physdem1
-                                                      !! whether or not tracer is on
+         IF (.NOT.ALLOCATED(noms)) ALLOCATE(noms(nq)) ! (because noms is an argument of physdem1 whether or not tracer is on)
          if (tracer) then
             call initracer(ngrid,nq,nametrac)
-         endif ! end tracer
-
-! 
-
-!        read startfi (initial parameters)
+         endif
+
+
+!        Read 'startfi.nc' file.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         call phyetat0(ngrid,nlayer,"startfi.nc",0,0,nsoilmx,nq,   &
-               day_ini,time_phys,tsurf,tsoil,emis,q2,qsurf,   &
-               cloudfrac,totcloudfrac,hice,  &
-               rnat,pctsrf_sic,tslab, tsea_ice,sea_ice)
+         call phyetat0(ngrid,nlayer,"startfi.nc",0,0,nsoilmx,nq,      &
+                       day_ini,time_phys,tsurf,tsoil,emis,q2,qsurf,   &
+                       cloudfrac,totcloudfrac,hice,                   &
+                       rnat,pctsrf_sic,tslab, tsea_ice,sea_ice)
 
          if (pday.ne.day_ini) then
@@ -559,5 +521,5 @@
          write (*,*) 'In physiq day_ini =', day_ini
 
-!        Initialize albedo and orbital calculation
+!        Initialize albedo and orbital calculation.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          call surfini(ngrid,nq,qsurf,albedo0)
@@ -571,15 +533,15 @@
          endif
 
-!        Initialize oceanic variables
-!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Initialize oceanic variables.
+!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
          if (ok_slab_ocean)then
 
            call ocean_slab_init(ngrid,ptimestep, tslab, &
-                sea_ice, pctsrf_sic)
-
-            knindex(:) = 0
-
-            do ig=1,ngrid
+                                sea_ice, pctsrf_sic)
+
+           knindex(:) = 0
+
+           do ig=1,ngrid
               zmasq(ig)=1
               knindex(ig) = ig
@@ -587,46 +549,45 @@
                  zmasq(ig)=0
               endif
-            enddo
-
+           enddo
 
            CALL init_masquv(ngrid,zmasq)
 
-
-         endif
-
-
-!        initialize soil 
-!        ~~~~~~~~~~~~~~~
+         endif ! end of 'ok_slab_ocean'.
+
+
+!        Initialize soil.
+!        ~~~~~~~~~~~~~~~~
          if (callsoil) then
+         
             call soil(ngrid,nsoilmx,firstcall,lastcall,inertiedat, &
-                ptimestep,tsurf,tsoil,capcal,fluxgrd)
+                      ptimestep,tsurf,tsoil,capcal,fluxgrd)
 
             if (ok_slab_ocean) then
                do ig=1,ngrid
                   if (nint(rnat(ig)).eq.2) then
-                    capcal(ig)=capcalocean
-                    if (pctsrf_sic(ig).gt.0.5) then
-                      capcal(ig)=capcalseaice
-                      if (qsurf(ig,igcm_h2o_ice).gt.0.) then
-                        capcal(ig)=capcalsno
-                      endif
-                    endif
+                     capcal(ig)=capcalocean
+                     if (pctsrf_sic(ig).gt.0.5) then
+                        capcal(ig)=capcalseaice
+                        if (qsurf(ig,igcm_h2o_ice).gt.0.) then
+                           capcal(ig)=capcalsno
+                        endif
+                     endif
                   endif
                enddo
-            endif
-
-
-
-
-         else
+            endif ! end of 'ok_slab_ocean'.
+
+         else ! else of 'callsoil'.
+         
             print*,'WARNING! Thermal conduction in the soil turned off'
             capcal(:)=1.e6
             fluxgrd(:)=intheat
             print*,'Flux from ground = ',intheat,' W m^-2'
-         endif
+            
+         endif ! end of 'callsoil'.
+         
          icount=1
 
-!        decide whether to update ice at end of run
-!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Decide whether to update ice at end of run.
+!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          ice_update=.false.
          if(sourceevol)then
@@ -635,7 +596,7 @@
                      status="old",iostat=ierr)
             if (ierr.ne.0) then
-              write(*,*) "physiq: Error! No num_run file!"
-              write(*,*) " (which is needed for sourceevol option)"
-              stop
+               write(*,*) "physiq: Error! No num_run file!"
+               write(*,*) " (which is needed for sourceevol option)"
+               stop
             endif
             read(128,*) num_run 
@@ -645,32 +606,35 @@
         
             if(num_run.ne.0.and.mod(num_run,2).eq.0)then
-            !if(num_run.ne.0.and.mod(num_run,3).eq.0)then
                print*,'Updating ice at end of this year!'
                ice_update=.true.
                ice_min(:)=1.e4
-            endif  
-         endif
-
-!  In newstart now, will have to be remove (BC 2014)
-!        define surface as continent or ocean
-!        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+            endif
+            
+         endif ! end of 'sourceevol'.
+
+
+         ! Here is defined the type of the surface : Continent or Ocean.
+         ! BC2014 : This is now already done in newstart.
+         ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          if (.not.ok_slab_ocean) then
+         
            rnat(:)=1.
            do ig=1,ngrid
-!             if(iceball.or.oceanball.or.(inertiedat(ig,1).gt.1.E4))then
-             if(inertiedat(ig,1).gt.1.E4)then
-               rnat(ig)=0
-             endif
+              if(inertiedat(ig,1).gt.1.E4)then
+                 rnat(ig)=0
+              endif
            enddo
 
            print*,'WARNING! Surface type currently decided by surface inertia'
            print*,'This should be improved e.g. in newstart.F'
-         endif!(.not.ok_slab_ocean)
-
-!        initialise surface history variable 
+           
+         endif ! end of 'ok_slab_ocean'.
+
+
+!        Initialize surface history variable.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          qsurf_hist(:,:)=qsurf(:,:)
 
-!        initialise variable for dynamical heating diagnostic
+!        Initialize variable for dynamical heating diagnostic.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          ztprevious(:,:)=pt(:,:)
@@ -688,17 +652,14 @@
          endif
 
-         if(meanOLR)then
-            ! to record global radiative balance
-            call system('rm -f rad_bal.out')
-            ! to record global mean/max/min temperatures
-            call system('rm -f tem_bal.out')
-            ! to record global hydrological balance
-            call system('rm -f h2o_bal.out')
-         endif
-
-         watertest=.false.
-         if(water)then
-            ! initialise variables for water cycle
-
+         if(meanOLR)then          
+            call system('rm -f rad_bal.out') ! to record global radiative balance.           
+            call system('rm -f tem_bal.out') ! to record global mean/max/min temperatures.            
+            call system('rm -f h2o_bal.out') ! to record global hydrological balance.
+         endif
+
+
+         watertest=.false.        
+         if(water)then ! Initialize variables for water cycle
+            
             if(enertest)then
                watertest = .true.
@@ -710,42 +671,41 @@
 
          endif
+         
          call su_watercycle ! even if we don't have a water cycle, we might
                             ! need epsi for the wvp definitions in callcorrk.F
 
-         if (ngrid.ne.1) then ! no need to create a restart file in 1d
-           call physdem0("restartfi.nc",long,lati,nsoilmx,ngrid,nlayer,nq, &
-                         ptimestep,pday+nday,time_phys,area, &
-                         albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
+         if (ngrid.ne.1) then ! Note : no need to create a restart file in 1d.
+            call physdem0("restartfi.nc",long,lati,nsoilmx,ngrid,nlayer,nq, &
+                          ptimestep,pday+nday,time_phys,area, &
+                          albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
          endif
          
-      endif        !  (end of "if firstcall")
-
-! ---------------------------------------------------
-! 1.2   Initializations done at every physical timestep:
-! ---------------------------------------------------
-!     Initialize various variables
-!     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-      
+      endif ! end of 'firstcall'
+
+! ------------------------------------------------------
+! I.2   Initializations done at every physical timestep:
+! ------------------------------------------------------
+
+      ! Initialize various variables
+      ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      
+      if ( .not.nearco2cond ) then
+         pdt(1:ngrid,1:nlayer) = 0.0
+      endif      
+      zdtsurf(1:ngrid)      = 0.0
+      pdq(1:ngrid,1:nlayer,1:nq) = 0.0
+      dqsurf(1:ngrid,1:nq)= 0.0
       pdu(1:ngrid,1:nlayer) = 0.0
       pdv(1:ngrid,1:nlayer) = 0.0
-      if ( .not.nearco2cond ) then
-         pdt(1:ngrid,1:nlayer) = 0.0
-      endif
-      pdq(1:ngrid,1:nlayer,1:nq) = 0.0
       pdpsrf(1:ngrid)       = 0.0
-      zflubid(1:ngrid)      = 0.0
-      zdtsurf(1:ngrid)      = 0.0
-      dqsurf(1:ngrid,1:nq)= 0.0
+      zflubid(1:ngrid)      = 0.0      
       flux_sens_lat(1:ngrid) = 0.0
       taux(1:ngrid) = 0.0
       tauy(1:ngrid) = 0.0
 
-
-
-
-      zday=pday+ptime ! compute time, in sols (and fraction thereof)
-
-!     Compute Stellar Longitude (Ls), and orbital parameters
-!     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      zday=pday+ptime ! Compute time, in sols (and fraction thereof).
+
+      ! Compute Stellar Longitude (Ls), and orbital parameters.
+      ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       if (season) then
          call stellarlong(zday,zls)
@@ -755,4 +715,5 @@
 
       call orbite(zls,dist_star,declin,right_ascen)
+      
       if (tlocked) then
               zlss=Mod(-(2.*pi*(zday/year_day)*nres - right_ascen),2.*pi)
@@ -764,34 +725,27 @@
 
 
-!    Compute variations of g with latitude (oblate case)
-!
-        if (oblate .eqv. .false.) then
-           glat(:) = g
-        else if (flatten .eq. 0.0 .or. J2 .eq. 0.0 .or. Rmean .eq. 0.0 .or. MassPlanet .eq. 0.0) then
-        print*,'I need values for flatten, J2, Rmean and MassPlanet to compute glat (else set oblate=.false.)'
-
-        call abort
-        else
-
-        gmplanet = MassPlanet*grav*1e24
-        do ig=1,ngrid
-           glat(ig)= gmplanet/(Rmean**2) * (1.D0 + 0.75 *J2 - 2.0*flatten/3. + (2.*flatten - 15./4.* J2) * cos(2. * (pi/2. - lati(ig)))) 
-        end do
-        endif
-
-!!      write(*,*) 'lati, glat =',lati(1)*180./pi,glat(1), lati(ngrid/2)*180./pi, glat(ngrid/2)
-
-
-
-!     Compute geopotential between layers
-!     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
+      ! Compute variations of g with latitude (oblate case).
+      ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      if (oblate .eqv. .false.) then      
+         glat(:) = g         
+      else if (flatten .eq. 0.0 .or. J2 .eq. 0.0 .or. Rmean .eq. 0.0 .or. MassPlanet .eq. 0.0) then      
+         print*,'I need values for flatten, J2, Rmean and MassPlanet to compute glat (else set oblate=.false.)'
+         call abort
+      else
+         gmplanet = MassPlanet*grav*1e24
+         do ig=1,ngrid
+            glat(ig)= gmplanet/(Rmean**2) * (1.D0 + 0.75 *J2 - 2.0*flatten/3. + (2.*flatten - 15./4.* J2) * cos(2. * (pi/2. - lati(ig)))) 
+         end do
+      endif
+
+      ! Compute geopotential between layers.
+      ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       zzlay(1:ngrid,1:nlayer)=pphi(1:ngrid,1:nlayer)
       do l=1,nlayer         
-      zzlay(1:ngrid,l)= zzlay(1:ngrid,l)/glat(1:ngrid)
+         zzlay(1:ngrid,l)= zzlay(1:ngrid,l)/glat(1:ngrid)
       enddo
 
       zzlev(1:ngrid,1)=0.
-      zzlev(1:ngrid,nlayer+1)=1.e7    ! dummy top of last layer above 10000 km...
+      zzlev(1:ngrid,nlayer+1)=1.e7 ! Dummy top of last layer above 10000 km...
 
       do l=2,nlayer
@@ -801,10 +755,9 @@
             zzlev(ig,l)=(z1*zzlay(ig,l-1)+z2*zzlay(ig,l))/(z1+z2)
          enddo
-      enddo
-!     Potential temperature calculation may not be the same in physiq and dynamic...
-
-!     Compute potential temperature
-!     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
+      enddo     
+
+      ! Compute potential temperature
+      ! Note : Potential temperature calculation may not be the same in physiq and dynamic...
+      ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       do l=1,nlayer         
          do ig=1,ngrid
@@ -818,49 +771,47 @@
      ! Compute vertical velocity (m/s) from vertical mass flux
      ! w = F / (rho*area) and rho = P/(r*T)
-     ! but first linearly interpolate mass flux to mid-layers
-     do l=1,nlayer-1
-       pw(1:ngrid,l)=0.5*(flxw(1:ngrid,l)+flxw(1:ngrid,l+1))
-     enddo
-     pw(1:ngrid,nlayer)=0.5*flxw(1:ngrid,nlayer) ! since flxw(nlayer+1)=0
-     do l=1,nlayer
-       pw(1:ngrid,l)=(pw(1:ngrid,l)*r*pt(1:ngrid,l)) /  &
-                     (pplay(1:ngrid,l)*area(1:ngrid))
-     enddo
-
-!-----------------------------------------------------------------------
-!    2. Compute radiative tendencies
-!-----------------------------------------------------------------------
+     ! But first linearly interpolate mass flux to mid-layers
+      do l=1,nlayer-1
+         pw(1:ngrid,l)=0.5*(flxw(1:ngrid,l)+flxw(1:ngrid,l+1))
+      enddo
+      pw(1:ngrid,nlayer)=0.5*flxw(1:ngrid,nlayer) ! since flxw(nlayer+1)=0
+      do l=1,nlayer
+         pw(1:ngrid,l)=(pw(1:ngrid,l)*r*pt(1:ngrid,l)) /  &
+                       (pplay(1:ngrid,l)*area(1:ngrid))
+      enddo
+
+!---------------------------------
+! II. Compute radiative tendencies
+!---------------------------------
 
       if (callrad) then
          if( mod(icount-1,iradia).eq.0.or.lastcall) then
 
-!          Compute local stellar zenith angles
-!          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-           if (tlocked) then
-! JL14 corrects tidally resonant (and inclined) cases. nres=omega_rot/omega_orb
-              ztim1=SIN(declin)
-              ztim2=COS(declin)*COS(zlss)
-              ztim3=COS(declin)*SIN(zlss)
-
-              call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
-               ztim1,ztim2,ztim3,mu0,fract, flatten)
-
-           elseif (diurnal) then
-              ztim1=SIN(declin)
-              ztim2=COS(declin)*COS(2.*pi*(zday-.5))
-              ztim3=-COS(declin)*SIN(2.*pi*(zday-.5))
-
-              call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
-               ztim1,ztim2,ztim3,mu0,fract, flatten)
-           else if(diurnal .eqv. .false.) then
+          ! Compute local stellar zenith angles
+          ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+            if (tlocked) then
+            ! JL14 corrects tidally resonant (and inclined) cases. nres=omega_rot/omega_orb
+               ztim1=SIN(declin)
+               ztim2=COS(declin)*COS(zlss)
+               ztim3=COS(declin)*SIN(zlss)
+
+               call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
+                            ztim1,ztim2,ztim3,mu0,fract, flatten)
+
+            elseif (diurnal) then
+               ztim1=SIN(declin)
+               ztim2=COS(declin)*COS(2.*pi*(zday-.5))
+               ztim3=-COS(declin)*SIN(2.*pi*(zday-.5))
+
+               call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
+                            ztim1,ztim2,ztim3,mu0,fract, flatten)
+            else if(diurnal .eqv. .false.) then
 
                call mucorr(ngrid,declin,lati,mu0,fract,10000.,rad,flatten)
                ! WARNING: this function appears not to work in 1D
 
-           endif 
+            endif 
            
-           !! Eclipse incoming sunlight (e.g. Saturn ring shadowing)
-        
+            ! Eclipse incoming sunlight (e.g. Saturn ring shadowing).       
             if(rings_shadow) then
                 call call_rings(ngrid, ptime, pday, diurnal)
@@ -868,138 +819,132 @@
 
 
-           if (corrk) then
-
-!          a) Call correlated-k radiative transfer scheme
-!          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-              if(kastprof)then
-                 print*,'kastprof should not = true here'
-                 call abort
-              endif
-	      if(water) then
+            if (corrk) then
+            
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+! II.a Call correlated-k radiative transfer scheme
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+               if(kastprof)then
+                  print*,'kastprof should not = true here'
+                  call abort
+               endif
+	       if(water) then
                   muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,1:nlayer,igcm_h2o_vap)) 
 		  muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi-1.e0)*pq(1:ngrid,nlayer,igcm_h2o_vap)) 
 		  ! take into account water effect on mean molecular weight
-	      else
+	       else
                   muvar(1:ngrid,1:nlayer+1)=mugaz
-	      endif 
-      
-!             standard callcorrk
-
-              if(ok_slab_ocean) then
-                tsurf2(:)=tsurf(:) 
-                do ig=1,ngrid
-                  if (nint(rnat(ig))==0) then
-                    tsurf(ig)=((1.-pctsrf_sic(ig))*tslab(ig,1)**4+pctsrf_sic(ig)*tsea_ice(ig)**4)**0.25
-                  endif
-                enddo
-              endif!(ok_slab_ocean)
+	       endif 
+      
+
+               if(ok_slab_ocean) then
+                  tsurf2(:)=tsurf(:) 
+                  do ig=1,ngrid
+                     if (nint(rnat(ig))==0) then
+                        tsurf(ig)=((1.-pctsrf_sic(ig))*tslab(ig,1)**4+pctsrf_sic(ig)*tsea_ice(ig)**4)**0.25
+                     endif
+                  enddo
+               endif !(ok_slab_ocean)
                 
-
-                clearsky=.false.
-                call callcorrk(ngrid,nlayer,pq,nq,qsurf,                   &
-                      albedo,emis,mu0,pplev,pplay,pt,                    &
-                      tsurf,fract,dist_star,aerosol,muvar,               &
-                      zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
-                      fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,               &
-                      tau_col,cloudfrac,totcloudfrac,                    &
-                      clearsky,firstcall,lastcall)      
-
-!             Option to call scheme once more for clear regions
-                if(CLFvarying)then
-
-                 ! ---> PROBLEMS WITH ALLOCATED ARRAYS 
-                 ! (temporary solution in callcorrk: do not deallocate if CLFvarying ...)
-                   clearsky=.true.
-                   call callcorrk(ngrid,nlayer,pq,nq,qsurf,                  &
-                      albedo,emis,mu0,pplev,pplay,pt,                      &
-                      tsurf,fract,dist_star,aerosol,muvar,                 &
-                      zdtlw1,zdtsw1,fluxsurf_lw1,fluxsurf_sw1,fluxtop_lw1, &
-                      fluxabs_sw1,fluxtop_dn,OLR_nu1,OSR_nu1,              &
-                      tau_col1,cloudfrac,totcloudfrac,                     &
-                      clearsky,firstcall,lastcall)
-                   clearsky = .false.  ! just in case.     
-
-
-                 ! Sum the fluxes and heating rates from cloudy/clear cases
-                   do ig=1,ngrid
-                      tf=totcloudfrac(ig)
-                      ntf=1.-tf
+               ! standard callcorrk
+               clearsky=.false.
+               call callcorrk(ngrid,nlayer,pq,nq,qsurf,                          &
+                              albedo,emis,mu0,pplev,pplay,pt,                    &
+                              tsurf,fract,dist_star,aerosol,muvar,               &
+                              zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
+                              fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,               &
+                              tau_col,cloudfrac,totcloudfrac,                    &
+                              clearsky,firstcall,lastcall)      
+
+                ! Option to call scheme once more for clear regions
+               if(CLFvarying)then
+
+                  ! ---> PROBLEMS WITH ALLOCATED ARRAYS : temporary solution in callcorrk: do not deallocate if CLFvarying ...
+                  clearsky=.true.
+                  call callcorrk(ngrid,nlayer,pq,nq,qsurf,                            &
+                                 albedo,emis,mu0,pplev,pplay,pt,                      &
+                                 tsurf,fract,dist_star,aerosol,muvar,                 &
+                                 zdtlw1,zdtsw1,fluxsurf_lw1,fluxsurf_sw1,fluxtop_lw1, &
+                                 fluxabs_sw1,fluxtop_dn,OLR_nu1,OSR_nu1,              &
+                                 tau_col1,cloudfrac,totcloudfrac,                     &
+                                 clearsky,firstcall,lastcall)
+                  clearsky = .false.  ! just in case.     
+
+
+                  ! Sum the fluxes and heating rates from cloudy/clear cases
+                  do ig=1,ngrid
+                     tf=totcloudfrac(ig)
+                     ntf=1.-tf
                     
-                    fluxsurf_lw(ig) = ntf*fluxsurf_lw1(ig) + tf*fluxsurf_lw(ig)
-                    fluxsurf_sw(ig) = ntf*fluxsurf_sw1(ig) + tf*fluxsurf_sw(ig)
-                    fluxtop_lw(ig)  = ntf*fluxtop_lw1(ig)  + tf*fluxtop_lw(ig)
-                    fluxabs_sw(ig)  = ntf*fluxabs_sw1(ig)  + tf*fluxabs_sw(ig)
-                    tau_col(ig)     = ntf*tau_col1(ig)     + tf*tau_col(ig)
+                     fluxsurf_lw(ig) = ntf*fluxsurf_lw1(ig) + tf*fluxsurf_lw(ig)
+                     fluxsurf_sw(ig) = ntf*fluxsurf_sw1(ig) + tf*fluxsurf_sw(ig)
+                     fluxtop_lw(ig)  = ntf*fluxtop_lw1(ig)  + tf*fluxtop_lw(ig)
+                     fluxabs_sw(ig)  = ntf*fluxabs_sw1(ig)  + tf*fluxabs_sw(ig)
+                     tau_col(ig)     = ntf*tau_col1(ig)     + tf*tau_col(ig)
                     
-                    zdtlw(ig,1:nlayer) = ntf*zdtlw1(ig,1:nlayer) + tf*zdtlw(ig,1:nlayer)
-                    zdtsw(ig,1:nlayer) = ntf*zdtsw1(ig,1:nlayer) + tf*zdtsw(ig,1:nlayer)
-
-                    OSR_nu(ig,1:L_NSPECTV) = ntf*OSR_nu1(ig,1:L_NSPECTV) + tf*OSR_nu(ig,1:L_NSPECTV)		       
-                    OLR_nu(ig,1:L_NSPECTI) = ntf*OLR_nu1(ig,1:L_NSPECTI) + tf*OLR_nu(ig,1:L_NSPECTI)		       
-
+                     zdtlw(ig,1:nlayer) = ntf*zdtlw1(ig,1:nlayer) + tf*zdtlw(ig,1:nlayer)
+                     zdtsw(ig,1:nlayer) = ntf*zdtsw1(ig,1:nlayer) + tf*zdtsw(ig,1:nlayer)
+
+                     OSR_nu(ig,1:L_NSPECTV) = ntf*OSR_nu1(ig,1:L_NSPECTV) + tf*OSR_nu(ig,1:L_NSPECTV)		       
+                     OLR_nu(ig,1:L_NSPECTI) = ntf*OLR_nu1(ig,1:L_NSPECTI) + tf*OLR_nu(ig,1:L_NSPECTI)		       
                  enddo
 
-              endif !CLFvarying
-
-              if(ok_slab_ocean) then
-                tsurf(:)=tsurf2(:)
-              endif!(ok_slab_ocean)
-
-
-!             Radiative flux from the sky absorbed by the surface (W.m-2)
-              GSR=0.0
-              fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)+fluxsurf_sw(1:ngrid)*(1.-albedo(1:ngrid))
-
-              !if(noradsurf)then ! no lower surface; SW flux just disappears
-              !   GSR = SUM(fluxsurf_sw(1:ngrid)*area(1:ngrid))/totarea
-              !   fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)
-              !   print*,'SW lost in deep atmosphere = ',GSR,' W m^-2'
-              !endif
-
-!             Net atmospheric radiative heating rate (K.s-1)
-              dtrad(1:ngrid,1:nlayer)=zdtsw(1:ngrid,1:nlayer)+zdtlw(1:ngrid,1:nlayer)
-
-           elseif(newtonian)then
-
-!          b) Call Newtonian cooling scheme
-!          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              call newtrelax(ngrid,nlayer,mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
-
-              zdtsurf(1:ngrid) = +(pt(1:ngrid,1)-tsurf(1:ngrid))/ptimestep
-              ! e.g. surface becomes proxy for 1st atmospheric layer ?
-
-           else
-
-!          c) Atmosphere has no radiative effect
-!          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              fluxtop_dn(1:ngrid)  = fract(1:ngrid)*mu0(1:ngrid)*Fat1AU/dist_star**2
-              if(ngrid.eq.1)then ! / by 4 globally in 1D case...
-                 fluxtop_dn(1)  = fract(1)*Fat1AU/dist_star**2/2.0
-              endif
-              fluxsurf_sw(1:ngrid) = fluxtop_dn(1:ngrid)
-              fluxrad_sky(1:ngrid) = fluxtop_dn(1:ngrid)*(1.-albedo(1:ngrid))
-              fluxtop_lw(1:ngrid)  = emis(1:ngrid)*sigma*tsurf(1:ngrid)**4
-              ! radiation skips the atmosphere entirely
-
-
-              dtrad(1:ngrid,1:nlayer)=0.0
-              ! hence no atmospheric radiative heating
-
-           endif                ! if corrk
-
-        endif ! of if(mod(icount-1,iradia).eq.0)
+               endif ! end of CLFvarying.
+
+               if(ok_slab_ocean) then
+                  tsurf(:)=tsurf2(:)
+               endif
+
+
+               ! Radiative flux from the sky absorbed by the surface (W.m-2)
+               GSR=0.0
+               fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)+fluxsurf_sw(1:ngrid)*(1.-albedo(1:ngrid))
+
+                            !if(noradsurf)then ! no lower surface; SW flux just disappears
+                            !   GSR = SUM(fluxsurf_sw(1:ngrid)*area(1:ngrid))/totarea
+                            !   fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)
+                            !   print*,'SW lost in deep atmosphere = ',GSR,' W m^-2'
+                            !endif
+
+               ! Net atmospheric radiative heating rate (K.s-1)
+               dtrad(1:ngrid,1:nlayer)=zdtsw(1:ngrid,1:nlayer)+zdtlw(1:ngrid,1:nlayer)
+
+            elseif(newtonian)then
+
+               ! II.b Call Newtonian cooling scheme
+               ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+               call newtrelax(ngrid,nlayer,mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
+
+               zdtsurf(1:ngrid) = +(pt(1:ngrid,1)-tsurf(1:ngrid))/ptimestep
+               ! e.g. surface becomes proxy for 1st atmospheric layer ?
+
+            else
+            
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+! II.c Atmosphere has no radiative effect 
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+               fluxtop_dn(1:ngrid)  = fract(1:ngrid)*mu0(1:ngrid)*Fat1AU/dist_star**2
+               if(ngrid.eq.1)then ! / by 4 globally in 1D case...
+                  fluxtop_dn(1)  = fract(1)*Fat1AU/dist_star**2/2.0
+               endif
+               fluxsurf_sw(1:ngrid) = fluxtop_dn(1:ngrid)
+               fluxrad_sky(1:ngrid) = fluxtop_dn(1:ngrid)*(1.-albedo(1:ngrid))
+               fluxtop_lw(1:ngrid)  = emis(1:ngrid)*sigma*tsurf(1:ngrid)**4
+
+               dtrad(1:ngrid,1:nlayer)=0.0 ! no atmospheric radiative heating
+
+            endif ! end of corrk
+
+         endif ! of if(mod(icount-1,iradia).eq.0)
        
 
-!    Transformation of the radiative tendencies
-!    ------------------------------------------
-
-        zplanck(1:ngrid)=tsurf(1:ngrid)*tsurf(1:ngrid)
-        zplanck(1:ngrid)=emis(1:ngrid)*sigma*zplanck(1:ngrid)*zplanck(1:ngrid)
-        fluxrad(1:ngrid)=fluxrad_sky(1:ngrid)-zplanck(1:ngrid)
-        pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+dtrad(1:ngrid,1:nlayer)
-
-!-------------------------
-! test energy conservation
+         ! Transformation of the radiative tendencies
+         ! ------------------------------------------
+         zplanck(1:ngrid)=tsurf(1:ngrid)*tsurf(1:ngrid)
+         zplanck(1:ngrid)=emis(1:ngrid)*sigma*zplanck(1:ngrid)*zplanck(1:ngrid)
+         fluxrad(1:ngrid)=fluxrad_sky(1:ngrid)-zplanck(1:ngrid)
+         pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+dtrad(1:ngrid,1:nlayer)
+         
+         ! Test of energy conservation
+         !----------------------------
          if(enertest)then
 	    call planetwide_sumval(cpp*massarea(:,:)*zdtsw(:,:)/totarea_planet,dEtotSW)
@@ -1010,20 +955,21 @@
 	    dEzRadlw(:,:)=cpp*mass(:,:)*zdtlw(:,:)
 	    if (is_master) then
-            	print*,'---------------------------------------------------------------'
-            	print*,'In corrk SW atmospheric heating       =',dEtotSW,' W m-2'
-            	print*,'In corrk LW atmospheric heating       =',dEtotLW,' W m-2'
-            	print*,'atmospheric net rad heating (SW+LW)   =',dEtotLW+dEtotSW,' W m-2'
-            	print*,'In corrk SW surface heating           =',dEtotsSW,' W m-2'
-            	print*,'In corrk LW surface heating           =',dEtotsLW,' W m-2'
-            	print*,'surface net rad heating (SW+LW)       =',dEtotsLW+dEtotsSW,' W m-2'
+               print*,'---------------------------------------------------------------'
+               print*,'In corrk SW atmospheric heating       =',dEtotSW,' W m-2'
+               print*,'In corrk LW atmospheric heating       =',dEtotLW,' W m-2'
+               print*,'atmospheric net rad heating (SW+LW)   =',dEtotLW+dEtotSW,' W m-2'
+               print*,'In corrk SW surface heating           =',dEtotsSW,' W m-2'
+               print*,'In corrk LW surface heating           =',dEtotsLW,' W m-2'
+               print*,'surface net rad heating (SW+LW)       =',dEtotsLW+dEtotsSW,' W m-2'
 	    endif
-         endif
-!-------------------------
+         endif ! end of 'enertest'
 
       endif ! of if (callrad)
 
-!-----------------------------------------------------------------------
-!    4. Vertical diffusion (turbulent mixing):
-!    -----------------------------------------
+
+
+!  --------------------------------------------
+!  III. Vertical diffusion (turbulent mixing) :
+!  --------------------------------------------
 
       if (calldifv) then
